//---------------------------------------------------------------------------
/*
GTST, Game Theory Server
Copyright (C) 2011 Richel Bilderbeek

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
//---------------------------------------------------------------------------
//From http://www.richelbilderbeek.nl/ProjectGtst.htm
//---------------------------------------------------------------------------
#include <boost/lexical_cast.hpp>
//---------------------------------------------------------------------------
#include "ipaddress.h"
#include "participant.h"
#include "participantstateloggedin.h"
//---------------------------------------------------------------------------
ParticipantStateLoggedIn::ParticipantStateLoggedIn(Participant * const participant)
  : ParticipantState(participant)
{

}
//---------------------------------------------------------------------------
const std::string ParticipantStateLoggedIn::ToAdminStr() const
{
  const Participant * const participant = GetParticipant();
  const std::string s
    = ToStr()
    + std::string(", ID: ")
    + (participant->CanGetId()
      ? boost::lexical_cast<std::string>(participant->GetId())
      : std::string("?NONE?"))
    + std::string(", IP address: ")
    + (participant->CanGetIpAddress()
      ? participant->GetIpAddress()->Get()
      : std::string("?NONE?"));
  return s;
}
//---------------------------------------------------------------------------

